#setwd("C:/Users/p.mendras/Dropbox/7 CNSA perequation/3 - Scripts/rshiny_note_ipp/dossier_app/")
#setwd("C:/Users/Pauline/Dropbox/7 CNSA perequation/3 - Scripts/rshiny_note_ipp/dossier_app/")
library(shiny)
library(shinyWidgets)
library(raster)
library(sf)
library(gtools)
library(viridis)
library(RColorBrewer)
library(ggplot2)
library(dplyr)
library(ggiraph)
library(shinyjs)
library(dplyr)
library(stringr)
library(openxlsx)
library(readxl)
library(readr)
library(writexl)
library(tidyr)
library(DT)
library(scales)
library(shinythemes)
library(shinydashboard)
library(tibble)

sessionInfo()

options(encoding = "UTF-8")

source("helpers.R")

#user interface

css <- "
.nowrap {
  white-space: nowrap;
}"

ui <-shinyUI(
  fluidPage(
    theme = "blue.css",
    titlePanel ("Perte d'autonomie des personnes âgées : quels besoins et quels coûts pour accompagner le virage domiciliaire ?"),
    
    fluidRow(
      column(12,
             HTML('&nbsp;'),
             h4(HTML(
               "<p>Cette application permet de simuler les besoins en aide professionnelle et les coûts liées à la prise en charge de la perte d'autonomie à l'horizon 2050, dans le cadre d'un virage domiciliaire. Les estimations utilisent les projections 
               du nombre de personnes âgées dépendantes par département, issues du modèle LIVIA développé par 
              la <a href='https://data.drees.solidarites-sante.gouv.fr/explore/dataset/projections-du-nombre-de-personnes-agees-en-perte-dautonomie-par-lieu-de-vie-mod/information/'>DREES</a> (scénario d'évolution de la dépendance intermédiaire, d'espérance de vie basse et de virage domiciliaire). 
               Les projections sont soit agrégées au niveau national, soit ventilées par département et selon le lieu de résidence (Ehpad et assimilés, logements ordinaires ou résidences autonomie) </p>"
             )),
             h4(HTML(   
             "<p> Les paramètres entrant en jeu dans ces projections sont librement modifiables, permettant d'imaginer et de comparer plusieurs scénarios de dépenses. </p>"
             )),
             h4(HTML(
               "<p>La méthologie employée est décrite dans la note IPP et la maquette de calcul (onglet Méthodologie) accompagnant cette application. </p>"
             )),
             h4(HTML(
               "<p>Cette application a été développée par l'<a href='https://www.ipp.eu/'>Institut des politiques publiques (IPP)</a> dans le cadre d'un projet
               de recherche financé par la Direction du financement de l'offre de la <a href='https://www.cnsa.fr/'>Caisse Nationale de Solidarite pour l'Autonomie (CNSA)</a>. </p>"
             ))
             ),
      fluidRow(
        column(
          11,
             div(img(src = "ipp_logo.png", height = 70),
                 style =
                   "text-align: center;"
          )),
             br(),
             h3(HTML("<b>Paramètres modifiables<b>"))
      ),
    fluidRow(
      column(
        3,
        wellPanel(
          numericInput(
            inputId = "tauxGIR1dansGIR12_d",
            label = "Taux de GIR 1 parmi les GIR 1-2 à domicile (%)",
            value = 0.147951203 ,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tauxGIR3dansGIR34_d",
            label = "Taux de GIR 3 parmi les GIR 3-4 à domicile (%)",
            value = 0.187718684 ,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tauxGIR1dansGIR12_e",
            label = "Taux de GIR 1 parmi les GIR 1-2 en établissement (%)",
            value = 0.353873653 ,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tauxGIR3dansGIR34_e",
            label = "Taux de GIR 3 parmi les GIR 3-4 en établissement (%)",
            value = 0.54557387 ,
            min = 0,
            max = 1
          ),
          style = "background: #C0D9DA"
        )
        ),
      column(
        3,
        wellPanel(
          numericInput(
            inputId = "tx_recours_APA_GIR1_d",
            label = "Ratio de bénéficiaires de l'APA parmi les GIR 1 à domicile (%)",
            value = 0.377,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tx_recours_APA_GIR2_d",
            label = "Ratio de bénéficiaires de l'APA parmi les GIR 2 à domicile (%)",
            value = 0.377,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tx_recours_APA_GIR3_d",
            label = "Ratio de bénéficiaires de l'APA parmi les GIR 3 à domicile (%)",
            value = 0.366,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tx_recours_APA_GIR4_d",
            label = "Ratio de bénéficiaires de l'APA parmi les GIR 4 à domicile (%)",
            value = 0.366,
            min = 0,
            max = 1
          ),
          style = "background: #C0D9DA"
        )
        ),
      column(
        3,
        wellPanel(
          numericInput(
            inputId = "tx_recours_APA_GIR1_e",
            label = "Ratio de bénéficiaires de l'APA parmi les GIR 1 en établissement (%)",
            value = 0.96,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tx_recours_APA_GIR2_e",
            label = "Ratio de bénéficiaires de l'APA parmi les GIR 2 en établissement (%)",
            value = 0.96,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tx_recours_APA_GIR3_e",
            label = "Ratio de bénéficiaires de l'APA parmi les GIR 3 en établissement (%)",
            value = 0.96,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "tx_recours_APA_GIR4_e",
            label = "Ratio de bénéficiaires de l'APA parmi les GIR 4 en établissement (%)",
            value = 0.96,
            min = 0,
            max = 1
          ),
          style = "background: #C0D9DA"
        )
        ),
      column(
        3,
        wellPanel(
          numericInput(
            inputId = "nb_heures_GIR1",
            label = "Nombre d'heures notifiées par mois pour les GIR 1",
            value = 63.7,
            min = 0,
            max = 744
          ),
          numericInput(
            inputId = "nb_heures_GIR2",
            label = "Nombre d'heures notifiées par mois pour les GIR 2",
            value = 49.4,
            min = 0,
            max = 744
          ),
          numericInput(
            inputId = "nb_heures_GIR3",
            label = "Nombre d'heures notifiées par mois  pour les GIR 3",
            value = 36.4,
            min = 0,
            max = 744
          ),
          numericInput(
            inputId = "nb_heures_GIR4",
            label = "Nombre d'heures notifiées par mois pour les GIR 4",
            value = 21.7,
            min = 0,
            max = 744
          ),
          style = "background: #C0D9DA"
        )
      ),
      column(
        3,
        offset = 0,
        wellPanel(
          numericInput(
            inputId = "pourc_plan_consomme_GIR1",
            label = "% consommé (par rapport au notifié) des GIR 1 en ménage ordinaire",
            value = 0.8267717,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_plan_consomme_GIR2",
            label = "% consommé (par rapport au notifié) des GIR 2 en ménage ordinaire",
            value = 0.8177083,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_plan_consomme_GIR3",
            label = "% consommé (par rapport au notifié) des GIR 3 en ménage ordinaire",
            value = 0.8,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_plan_consomme_GIR4",
            label = "% consommé (par rapport au notifié) des GIR 4 en ménage ordinaire",
            value = 0.7945946,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_plan_consomme_GIR1_HI",
            label = "% consommé (par rapport au notifié) des GIR 1 en résidence autonomie",
            value = 0.8267717,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_plan_consomme_GIR2_HI",
            label = "% consommé (par rapport au notifié) des GIR 2 en résidence autonomie",
            value = 0.8177083,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_plan_consomme_GIR3_HI",
            label = "% consommé (par rapport au notifié) des GIR 3 en résidence autonomie",
            value = 0.8,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_plan_consomme_GIR4_HI",
            label = "% consommé (par rapport au notifié) des GIR 4 en résidence autonomie",
            value = 0.7945946,
            min = 0,
            max = 1
          ),
          style = "background: #C0D9DA"
        )
      ),
      column(
        3,
        offset = 0,
        wellPanel(
          numericInput(
            inputId = "cout_heure_dom_presta",
            label = "Coût horaire de l'aide à domicile en mode prestataire (en €)",
            value = as.numeric(24),
            min = 0
          ),
          numericInput(
            inputId = "cout_heure_dom_greagre",
            label = "Coût horaire des services gré à gré (en €)",
            value = as.numeric(18),
            min = 0
          ),
          numericInput(
            inputId = "evol_cout_heure_dom_presta",
            label = "Taux d'évolution annuel du coût horaire de l'aide à domicile en mode prestataire (%)",
            value = 0.0215920915712799,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "evol_cout_heure_dom_greagre",
            label = "Taux d'évolution annuel du coût horaire des services gré à gré (%)",
            value = 0.0215920915712799,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "evol_cout_etab",
            label = "Taux d'évolution annuel du coût en établissement (%)",
            value = 0.01,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "cout_hors_aide_humaine",
            label = "Coût annuel de l'aide hors aide humaine (en €)",
            value = 39,
            min = 0,
            max = 1000
          ),
          numericInput(
            inputId = "cout_HI",
            label = "Coût supplémentaire en résidence autonomie (en €)",
            value = 0,
            min = 0,
            max = 1000
          ),
          style = "background: #C0D9DA"
        )
      ),
        column(
          3,
          offset = 0,
        wellPanel(
          numericInput(
            inputId = "plafond_GIR1_ini",
            label = "Plafond APA des GIR 1 à domicile (en €)",
            value = 1914.04,
            min = 0,
            max = 3000
          ),
          numericInput(
            inputId = "plafond_GIR2_ini",
            label = "Plafond APA des GIR 2 à domicile (en €)",
            value = 1547.93,
            min = 0,
            max = 3000
          ),
          numericInput(
            inputId = "plafond_GIR3_ini",
            label = "Plafond APA des GIR 3 à domicile (en €)",
            value = 1118.61,
            min = 0,
            max = 3000
          ),
          numericInput(
            inputId = "plafond_GIR4_ini",
            label = "Plafond APA des GIR 4 à domicile (en €)",
            value = 746.54,
            min = 0,
            max = 3000
          ),
          numericInput(
            inputId = "hyp_evol_plafond",
            label = "Taux d'évolution annuel des plafonds d'APA (%)",
            value = 0.01,
            min = 0,
            max = 1
          ),
          style = "background: #C0D9DA"
        )
        ),
      column(
        3,
        offset = 0,
        wellPanel(
          numericInput(
            inputId = "pourc_h_greagre_GIR1",
            label = "Pourcentage de services gré à gré GIR1 (%)",
            value = 0.223,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_h_greagre_GIR2",
            label = "Pourcentage de services gré à gré GIR2 (%)",
            value = 0.161,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_h_greagre_GIR3",
            label = "Pourcentage de services gré à gré GIR3 (%)",
            value = 0.141,
            min = 0,
            max = 1
          ),
          numericInput(
            inputId = "pourc_h_greagre_GIR4",
            label = "Pourcentage de services gré à gré GIR4 (%)",
            value = 0.13,
            min = 0,
            max = 1
          ),
          style = "background: #C0D9DA"
        )
        ),
      ),
      mainPanel(tabsetPanel(
        tabPanel(
          "Graphiques nationaux", 
          selectInput("tendance_nationale", 
                      label = "Tendance à afficher",
                      choices = c("Dépense d'APA",
                                  "Dépense d'APA et OGD",
                                  "Nombre de bénéficiaires de l'APA",
                                  "Nombre de personnes âgées",
                                  "Nombre de personnes âgée en GIR 1-4",
                                  "Nombre de points GIR 1-4",
                                  "Nombre de points GIR 1-6",
                                  "Nombre de points GIR 1-4 des bénéficiaires de l'APA",
                                  "Nombre d'ETP en SAAD",
                                  "Nombre de places en SSIAD",
                                  "Nombre de places en HAD",
                                  "Nombre d'infirmières libérales (en ETP)",
                                  "Nombre de personnel en établissement(en ETP)"),
                      selected = "Dépense d'APA"),
          plotOutput(outputId = "plot_national")
        ),
      tabPanel(
        "Graphiques départementaux", 
        fluidRow(
          column(
            3,
        selectInput("tendance_departementale", 
                    label = "Tendance à afficher",
                    choices = c("Dépense d'APA",
                                "Dépense d'APA et OGD",
                                "Nombre de bénéficiaires de l'APA",
                                "Nombre de personnes âgées",
                                "Nombre de personnes âgée en GIR 1-4",
                                "Nombre de points GIR 1-4",
                                "Nombre de points GIR 1-6",
                                "Nombre de points GIR 1-4 des bénéficiaires de l'APA",
                                "Nombre d'ETP en SAAD",
                                "Nombre de places en SSIAD",
                                "Nombre de places en HAD",
                                "Nombre d'infirmières libérales (en ETP)",
                                "Nombre de personnel en établissement(en ETP)"),
                    selected = "Dépense d'APA")
        ),
        column(
          3,
        selectInput("departement",
                    label = "Département",
                    choices = c("01 - Ain",
                                "02 - Aisne",
                                "03 - Allier",
                                "04 - Alpes de Haute-Garonne",
                                "05 - Hautes-Alpes",
                                "06 - Alpes-Maritimes",
                                "07 - Ardèche",
                                "08 - Ardennes",
                                "09 - Ariège",
                                "10 - Aube",
                                "11 - Aude",
                                "12 - Aveyron",
                                "13 - Bouches-du-Rhône",
                                "14 - Calvados",
                                "15 - Cantal",
                                "16 - Charente",
                                "17 - Charente-Maritime",
                                "18 - Cher",
                                "19 - Corrèze",
                                "21 - Côte d'Or",
                                "22 - Côtes d'Armor",
                                "23 - Creuse",
                                "24 - Dordogne",
                                "25 - Doubs",
                                "26 - Drôme",
                                "27 - Eure",
                                "28 - Eure-et-Loire",
                                "29 - Finistère",
                                "2A - Corse-du-Sud",
                                "2B - Haute-Corse",
                                "30 - Gard",
                                "31 - Haute-Garonne",
                                "32 - Gers",
                                "33 - Gironde",
                                "34 - Hérault",
                                "35 - Ille-et-Vilaine",
                                "36 - Indre",
                                "37 - Indre-et-Loire",
                                "38 - Isère",
                                "39 - Jura",
                                "40 - Landes",
                                "41 - Loire-et-Cher",
                                "42 - Loire",
                                "43 - Haute-Loire",
                                "44 - Loire-Atlantique",
                                "45 - Loiret",
                                "46 - Lot",
                                "47 - Lot-et-Garonne",
                                "48 - Lozère",
                                "49 - Maine-et-Loire",
                                "50 - Manche",
                                "51 - Marne",
                                "52 - Haute-Marne",
                                "53 - Mayenne",
                                "54 - Meurthe-et-Moselle",
                                "55 - Meuse",
                                "56 - Morbihan",
                                "57 - Moselle",
                                "58 - Nièvre",
                                "59 - Nord",
                                "60 - Oise",
                                "61 - Orne",
                                "62 - Pas-de-Calais",
                                "63 - Puy-de-Dôme",
                                "64 - Pyrénées-Atlantiques",
                                "65 - Hautes-Pyrénées",
                                "66 - Pyrénées Orientales",
                                "67 - Bas-Rhin",
                                "68 - Haut-Rhin",
                                "69 - Rhône",
                                "70 - Haute-Saône",
                                "71 - Saône-et-Loire",
                                "72 - Sarthe",
                                "73 - Savoie",
                                "74 - Haute-Savoie",
                                "75 - Paris",
                                "76 - Seine-Maritime",
                                "77 - Seine-et-Marne",
                                "78 - Yvelines",
                                "79 - Deux-Sèvres",
                                "80 - Somme",
                                "81 - Tarn",
                                "82 - Tarn-et-Garonne",
                                "83 - Var",
                                "84 - Vaucluse",
                                "85 - Vendée",
                                "86 - Vienne",
                                "87 - Haute-Vienne",
                                "88 - Vosges",
                                "89 - Yonne",
                                "90 - Territoire de Belfort",
                                "91 - Essonne",
                                "92 - Hauts-de-Seine",
                                "93 - Seine-Saint-Denis",
                                "94 - Val-de-Marne",
                                "95 - Val d'Oise",
                                "97 - DOM-TOM"
                                ),
                    selected = "01 - Ain")
        )
        ),
        plotOutput(outputId = "plot_departemental"), 
      ),
      tabPanel("Tableau national",
               fluidRow(
                 column(
                   3,
                   selectInput("annee", 
                               label = "Année",
                               choices = c("2020", "2021", "2022", "2023", "2024", "2025", "2026", "2027", "2028", "2029",
                                           "2030", "2031", "2032", "2033", "2034", "2035", "2036", "2037", "2038", "2039",
                                           "2040", "2041", "2042", "2043", "2044", "2045", "2046", "2047", "2048", "2049",
                                           "2050",
                                           "Toutes les années"),
                               selected = "Toutes les années")
                 ),
                 column(
                   3,
                   selectInput("habitat",
                               label = "Lieu de vie",
                               choices = c("Ehpad et assimilés",
                                           "Ménage ordinaire",
                                           "Résidence autonomie",
                                           "Tous les lieux de vie"),
                               selected = "Tous les lieux de vie")
                 )
               ),
               DTOutput("table_nationale")
               ),
      tabPanel("Tableau départemental",
               fluidRow(
                 column(
                   3,
                   selectInput("annee_dpt", 
                               label = "Année",
                               choices = c("2020", "2021", "2022", "2023", "2024", "2025", "2026", "2027", "2028", "2029",
                                           "2030", "2031", "2032", "2033", "2034", "2035", "2036", "2037", "2038", "2039",
                                           "2040", "2041", "2042", "2043", "2044", "2045", "2046", "2047", "2048", "2049",
                                           "2050",
                                           "Toutes les années"),
                               selected = "Toutes les années")
                 ),
                 column(
                   3,
                   selectInput("habitat_dpt",
                               label = "Lieu de vie",
                               choices = c("Ehpad et assimilés",
                                           "Ménage ordinaire",
                                           "Résidence autonomie",
                                           "Tous les lieux de vie"),
                               selected = "Tous les lieux de vie")
                 ),
                column(
                  3,
                  selectInput("departement_dpt",
                              label = "Département",
                              choices = c("01 - Ain",
                                          "02 - Aisne",
                                          "03 - Allier",
                                          "04 - Alpes de Haute-Garonne",
                                          "05 - Hautes-Alpes",
                                          "06 - Alpes-Maritimes",
                                          "07 - Ardèche",
                                          "08 - Ardennes",
                                          "09 - Ariège",
                                          "10 - Aube",
                                          "11 - Aude",
                                          "12 - Aveyron",
                                          "13 - Bouches-du-Rhône",
                                          "14 - Calvados",
                                          "15 - Cantal",
                                          "16 - Charente",
                                          "17 - Charente-Maritime",
                                          "18 - Cher",
                                          "19 - Corrèze",
                                          "21 - Côte d'Or",
                                          "22 - Côtes d'Armor",
                                          "23 - Creuse",
                                          "24 - Dordogne",
                                          "25 - Doubs",
                                          "26 - Drôme",
                                          "27 - Eure",
                                          "28 - Eure-et-Loire",
                                          "29 - Finistère",
                                          "2A - Corse-du-Sud",
                                          "2B - Haute-Corse",
                                          "30 - Gard",
                                          "31 - Haute-Garonne",
                                          "32 - Gers",
                                          "33 - Gironde",
                                          "34 - Hérault",
                                          "35 - Ille-et-Vilaine",
                                          "36 - Indre",
                                          "37 - Indre-et-Loire",
                                          "38 - Isère",
                                          "39 - Jura",
                                          "40 - Landes",
                                          "41 - Loire-et-Cher",
                                          "42 - Loire",
                                          "43 - Haute-Loire",
                                          "44 - Loire-Atlantique",
                                          "45 - Loiret",
                                          "46 - Lot",
                                          "47 - Lot-et-Garonne",
                                          "48 - Lozère",
                                          "49 - Maine-et-Loire",
                                          "50 - Manche",
                                          "51 - Marne",
                                          "52 - Haute-Marne",
                                          "53 - Mayenne",
                                          "54 - Meurthe-et-Moselle",
                                          "55 - Meuse",
                                          "56 - Morbihan",
                                          "57 - Moselle",
                                          "58 - Nièvre",
                                          "59 - Nord",
                                          "60 - Oise",
                                          "61 - Orne",
                                          "62 - Pas-de-Calais",
                                          "63 - Puy-de-Dôme",
                                          "64 - Pyrénées-Atlantiques",
                                          "65 - Hautes-Pyrénées",
                                          "66 - Pyrénées Orientales",
                                          "67 - Bas-Rhin",
                                          "68 - Haut-Rhin",
                                          "69 - Rhône",
                                          "70 - Haute-Saône",
                                          "71 - Saône-et-Loire",
                                          "72 - Sarthe",
                                          "73 - Savoie",
                                          "74 - Haute-Savoie",
                                          "75 - Paris",
                                          "76 - Seine-Maritime",
                                          "77 - Seine-et-Marne",
                                          "78 - Yvelines",
                                          "79 - Deux-Sèvres",
                                          "80 - Somme",
                                          "81 - Tarn",
                                          "82 - Tarn-et-Garonne",
                                          "83 - Var",
                                          "84 - Vaucluse",
                                          "85 - Vendée",
                                          "86 - Vienne",
                                          "87 - Haute-Vienne",
                                          "88 - Vosges",
                                          "89 - Yonne",
                                          "90 - Territoire de Belfort",
                                          "91 - Essonne",
                                          "92 - Hauts-de-Seine",
                                          "93 - Seine-Saint-Denis",
                                          "94 - Val-de-Marne",
                                          "95 - Val d'Oise",
                                          "97 - DOM-TOM",
                                          "Tous les départements"
                              ),
                              selected = "Tous les départements")
                )
               ),
               DTOutput("table_departementale")
      )
      ),
      width = 11
    )
)
))





# Define server logic ----
server <- function(input, output, session) {
  
  df_national <- reactive({evol_national(tauxGIR1dansGIR12_d = input$tauxGIR1dansGIR12_d,
                      tauxGIR3dansGIR34_d = input$tauxGIR3dansGIR34_d,
                      tauxGIR1dansGIR12_e = input$tauxGIR1dansGIR12_e,
                      tauxGIR3dansGIR34_e = input$tauxGIR3dansGIR34_e,
                      tx_recours_APA_GIR1_d = input$tx_recours_APA_GIR1_d,
                      tx_recours_APA_GIR2_d = input$tx_recours_APA_GIR2_d,
                      tx_recours_APA_GIR3_d = input$tx_recours_APA_GIR3_d,
                      tx_recours_APA_GIR4_d = input$tx_recours_APA_GIR4_d,
                      tx_recours_APA_GIR1_e = input$tx_recours_APA_GIR1_e,
                      tx_recours_APA_GIR2_e = input$tx_recours_APA_GIR2_e,
                      tx_recours_APA_GIR3_e = input$tx_recours_APA_GIR3_e,
                      tx_recours_APA_GIR4_e = input$tx_recours_APA_GIR4_e,
                      plafond_GIR1_ini = input$plafond_GIR1_ini,
                      plafond_GIR2_ini = input$plafond_GIR2_ini,
                      plafond_GIR3_ini = input$plafond_GIR3_ini,
                      plafond_GIR4_ini = input$plafond_GIR4_ini,
                      hyp_evol_plafond = input$hyp_evol_plafond,
                      pourc_plan_consomme_GIR1 = input$pourc_plan_consomme_GIR1,
                      pourc_plan_consomme_GIR2 = input$pourc_plan_consomme_GIR2,
                      pourc_plan_consomme_GIR3 = input$pourc_plan_consomme_GIR3,
                      pourc_plan_consomme_GIR4 = input$pourc_plan_consomme_GIR4,
                      pourc_plan_consomme_GIR1_HI = input$pourc_plan_consomme_GIR1_HI,
                      pourc_plan_consomme_GIR2_HI = input$pourc_plan_consomme_GIR2_HI,
                      pourc_plan_consomme_GIR3_HI = input$pourc_plan_consomme_GIR3_HI,
                      pourc_plan_consomme_GIR4_HI = input$pourc_plan_consomme_GIR4_HI,
                      nb_heures_GIR1 = input$nb_heures_GIR1,
                      nb_heures_GIR2 = input$nb_heures_GIR2,
                      nb_heures_GIR3 = input$nb_heures_GIR3,
                      nb_heures_GIR4 = input$nb_heures_GIR4,
                      cout_heure_dom_presta = input$cout_heure_dom_presta,
                      evol_cout_heure_dom_presta = input$evol_cout_heure_dom_presta,
                      cout_heure_dom_greagre = input$cout_heure_dom_greagre,
                      pourc_h_greagre_GIR1 = input$pourc_h_greagre_GIR1,
                      pourc_h_greagre_GIR2 = input$pourc_h_greagre_GIR2,
                      pourc_h_greagre_GIR3 = input$pourc_h_greagre_GIR3,
                      pourc_h_greagre_GIR4 = input$pourc_h_greagre_GIR4,
                      evol_cout_heure_dom_greagre = input$evol_cout_heure_dom_greagre,
                      evol_cout_etab = input$evol_cout_etab,
                      cout_HI = input$cout_HI,
                      cout_hors_aide_humaine = input$cout_hors_aide_humaine)})
  
  df_OGD <- reactive({evol_OGD(tauxGIR1dansGIR12_d = input$tauxGIR1dansGIR12_d,
                                    tauxGIR3dansGIR34_d = input$tauxGIR3dansGIR34_d,
                                    tauxGIR1dansGIR12_e = input$tauxGIR1dansGIR12_e,
                                    tauxGIR3dansGIR34_e = input$tauxGIR3dansGIR34_e,
                                    tx_recours_APA_GIR1_d = input$tx_recours_APA_GIR1_d,
                                    tx_recours_APA_GIR2_d = input$tx_recours_APA_GIR2_d,
                                    tx_recours_APA_GIR3_d = input$tx_recours_APA_GIR3_d,
                                    tx_recours_APA_GIR4_d = input$tx_recours_APA_GIR4_d,
                                    tx_recours_APA_GIR1_e = input$tx_recours_APA_GIR1_e,
                                    tx_recours_APA_GIR2_e = input$tx_recours_APA_GIR2_e,
                                    tx_recours_APA_GIR3_e = input$tx_recours_APA_GIR3_e,
                                    tx_recours_APA_GIR4_e = input$tx_recours_APA_GIR4_e,
                                    plafond_GIR1_ini = input$plafond_GIR1_ini,
                                    plafond_GIR2_ini = input$plafond_GIR2_ini,
                                    plafond_GIR3_ini = input$plafond_GIR3_ini,
                                    plafond_GIR4_ini = input$plafond_GIR4_ini,
                                    hyp_evol_plafond = input$hyp_evol_plafond,
                                    pourc_plan_consomme_GIR1 = input$pourc_plan_consomme_GIR1,
                                    pourc_plan_consomme_GIR2 = input$pourc_plan_consomme_GIR2,
                                    pourc_plan_consomme_GIR3 = input$pourc_plan_consomme_GIR3,
                                    pourc_plan_consomme_GIR4 = input$pourc_plan_consomme_GIR4,
                                    pourc_plan_consomme_GIR1_HI = input$pourc_plan_consomme_GIR1_HI,
                                    pourc_plan_consomme_GIR2_HI = input$pourc_plan_consomme_GIR2_HI,
                                    pourc_plan_consomme_GIR3_HI = input$pourc_plan_consomme_GIR3_HI,
                                    pourc_plan_consomme_GIR4_HI = input$pourc_plan_consomme_GIR4_HI,
                                    nb_heures_GIR1 = input$nb_heures_GIR1,
                                    nb_heures_GIR2 = input$nb_heures_GIR2,
                                    nb_heures_GIR3 = input$nb_heures_GIR3,
                                    nb_heures_GIR4 = input$nb_heures_GIR4,
                                    cout_heure_dom_presta = input$cout_heure_dom_presta,
                                    evol_cout_heure_dom_presta = input$evol_cout_heure_dom_presta,
                                    cout_heure_dom_greagre = input$cout_heure_dom_greagre,
                                    pourc_h_greagre_GIR1 = input$pourc_h_greagre_GIR1,
                                    pourc_h_greagre_GIR2 = input$pourc_h_greagre_GIR2,
                                    pourc_h_greagre_GIR3 = input$pourc_h_greagre_GIR3,
                                    pourc_h_greagre_GIR4 = input$pourc_h_greagre_GIR4,
                                    evol_cout_heure_dom_greagre = input$evol_cout_heure_dom_greagre,
                                    evol_cout_etab = input$evol_cout_etab,
                                    cout_HI = input$cout_HI,
                                    cout_hors_aide_humaine = input$cout_hors_aide_humaine)})
  
  df_departemental <- reactive({evol_departemental(tauxGIR1dansGIR12_d = input$tauxGIR1dansGIR12_d,
                                              tauxGIR3dansGIR34_d = input$tauxGIR3dansGIR34_d,
                                              tauxGIR1dansGIR12_e = input$tauxGIR1dansGIR12_e,
                                              tauxGIR3dansGIR34_e = input$tauxGIR3dansGIR34_e,
                                              tx_recours_APA_GIR1_d = input$tx_recours_APA_GIR1_d,
                                              tx_recours_APA_GIR2_d = input$tx_recours_APA_GIR2_d,
                                              tx_recours_APA_GIR3_d = input$tx_recours_APA_GIR3_d,
                                              tx_recours_APA_GIR4_d = input$tx_recours_APA_GIR4_d,
                                              tx_recours_APA_GIR1_e = input$tx_recours_APA_GIR1_e,
                                              tx_recours_APA_GIR2_e = input$tx_recours_APA_GIR2_e,
                                              tx_recours_APA_GIR3_e = input$tx_recours_APA_GIR3_e,
                                              tx_recours_APA_GIR4_e = input$tx_recours_APA_GIR4_e,
                                              plafond_GIR1_ini = input$plafond_GIR1_ini,
                                              plafond_GIR2_ini = input$plafond_GIR2_ini,
                                              plafond_GIR3_ini = input$plafond_GIR3_ini,
                                              plafond_GIR4_ini = input$plafond_GIR4_ini,
                                              hyp_evol_plafond = input$hyp_evol_plafond,
                                              pourc_plan_consomme_GIR1 = input$pourc_plan_consomme_GIR1,
                                              pourc_plan_consomme_GIR2 = input$pourc_plan_consomme_GIR2,
                                              pourc_plan_consomme_GIR3 = input$pourc_plan_consomme_GIR3,
                                              pourc_plan_consomme_GIR4 = input$pourc_plan_consomme_GIR4,
                                              pourc_plan_consomme_GIR1_HI = input$pourc_plan_consomme_GIR1_HI,
                                              pourc_plan_consomme_GIR2_HI = input$pourc_plan_consomme_GIR2_HI,
                                              pourc_plan_consomme_GIR3_HI = input$pourc_plan_consomme_GIR3_HI,
                                              pourc_plan_consomme_GIR4_HI = input$pourc_plan_consomme_GIR4_HI,
                                              nb_heures_GIR1 = input$nb_heures_GIR1,
                                              nb_heures_GIR2 = input$nb_heures_GIR2,
                                              nb_heures_GIR3 = input$nb_heures_GIR3,
                                              nb_heures_GIR4 = input$nb_heures_GIR4,
                                              cout_heure_dom_presta = input$cout_heure_dom_presta,
                                              evol_cout_heure_dom_presta = input$evol_cout_heure_dom_presta,
                                              cout_heure_dom_greagre = input$cout_heure_dom_greagre,
                                              pourc_h_greagre_GIR1 = input$pourc_h_greagre_GIR1,
                                              pourc_h_greagre_GIR2 = input$pourc_h_greagre_GIR2,
                                              pourc_h_greagre_GIR3 = input$pourc_h_greagre_GIR3,
                                              pourc_h_greagre_GIR4 = input$pourc_h_greagre_GIR4,
                                              evol_cout_heure_dom_greagre = input$evol_cout_heure_dom_greagre,
                                              evol_cout_etab = input$evol_cout_etab,
                                              cout_HI = input$cout_HI,
                                              cout_hors_aide_humaine = input$cout_hors_aide_humaine)})
  
  df_OGD_dpt <- reactive({evol_OGD_dpt(tauxGIR1dansGIR12_d = input$tauxGIR1dansGIR12_d,
                                   tauxGIR3dansGIR34_d = input$tauxGIR3dansGIR34_d,
                                   tauxGIR1dansGIR12_e = input$tauxGIR1dansGIR12_e,
                                   tauxGIR3dansGIR34_e = input$tauxGIR3dansGIR34_e,
                                   tx_recours_APA_GIR1_d = input$tx_recours_APA_GIR1_d,
                                   tx_recours_APA_GIR2_d = input$tx_recours_APA_GIR2_d,
                                   tx_recours_APA_GIR3_d = input$tx_recours_APA_GIR3_d,
                                   tx_recours_APA_GIR4_d = input$tx_recours_APA_GIR4_d,
                                   tx_recours_APA_GIR1_e = input$tx_recours_APA_GIR1_e,
                                   tx_recours_APA_GIR2_e = input$tx_recours_APA_GIR2_e,
                                   tx_recours_APA_GIR3_e = input$tx_recours_APA_GIR3_e,
                                   tx_recours_APA_GIR4_e = input$tx_recours_APA_GIR4_e,
                                   plafond_GIR1_ini = input$plafond_GIR1_ini,
                                   plafond_GIR2_ini = input$plafond_GIR2_ini,
                                   plafond_GIR3_ini = input$plafond_GIR3_ini,
                                   plafond_GIR4_ini = input$plafond_GIR4_ini,
                                   hyp_evol_plafond = input$hyp_evol_plafond,
                                   pourc_plan_consomme_GIR1 = input$pourc_plan_consomme_GIR1,
                                   pourc_plan_consomme_GIR2 = input$pourc_plan_consomme_GIR2,
                                   pourc_plan_consomme_GIR3 = input$pourc_plan_consomme_GIR3,
                                   pourc_plan_consomme_GIR4 = input$pourc_plan_consomme_GIR4,
                                   pourc_plan_consomme_GIR1_HI = input$pourc_plan_consomme_GIR1_HI,
                                   pourc_plan_consomme_GIR2_HI = input$pourc_plan_consomme_GIR2_HI,
                                   pourc_plan_consomme_GIR3_HI = input$pourc_plan_consomme_GIR3_HI,
                                   pourc_plan_consomme_GIR4_HI = input$pourc_plan_consomme_GIR4_HI,
                                   nb_heures_GIR1 = input$nb_heures_GIR1,
                                   nb_heures_GIR2 = input$nb_heures_GIR2,
                                   nb_heures_GIR3 = input$nb_heures_GIR3,
                                   nb_heures_GIR4 = input$nb_heures_GIR4,
                                   cout_heure_dom_presta = input$cout_heure_dom_presta,
                                   evol_cout_heure_dom_presta = input$evol_cout_heure_dom_presta,
                                   cout_heure_dom_greagre = input$cout_heure_dom_greagre,
                                   pourc_h_greagre_GIR1 = input$pourc_h_greagre_GIR1,
                                   pourc_h_greagre_GIR2 = input$pourc_h_greagre_GIR2,
                                   pourc_h_greagre_GIR3 = input$pourc_h_greagre_GIR3,
                                   pourc_h_greagre_GIR4 = input$pourc_h_greagre_GIR4,
                                   evol_cout_heure_dom_greagre = input$evol_cout_heure_dom_greagre,
                                   evol_cout_etab = input$evol_cout_etab,
                                   cout_HI = input$cout_HI,
                                   cout_hors_aide_humaine = input$cout_hors_aide_humaine)})
  
  table_nationale <- reactive({table_natio(tauxGIR1dansGIR12_d = input$tauxGIR1dansGIR12_d,
                                       tauxGIR3dansGIR34_d = input$tauxGIR3dansGIR34_d,
                                       tauxGIR1dansGIR12_e = input$tauxGIR1dansGIR12_e,
                                       tauxGIR3dansGIR34_e = input$tauxGIR3dansGIR34_e,
                                       tx_recours_APA_GIR1_d = input$tx_recours_APA_GIR1_d,
                                       tx_recours_APA_GIR2_d = input$tx_recours_APA_GIR2_d,
                                       tx_recours_APA_GIR3_d = input$tx_recours_APA_GIR3_d,
                                       tx_recours_APA_GIR4_d = input$tx_recours_APA_GIR4_d,
                                       tx_recours_APA_GIR1_e = input$tx_recours_APA_GIR1_e,
                                       tx_recours_APA_GIR2_e = input$tx_recours_APA_GIR2_e,
                                       tx_recours_APA_GIR3_e = input$tx_recours_APA_GIR3_e,
                                       tx_recours_APA_GIR4_e = input$tx_recours_APA_GIR4_e,
                                       plafond_GIR1_ini = input$plafond_GIR1_ini,
                                       plafond_GIR2_ini = input$plafond_GIR2_ini,
                                       plafond_GIR3_ini = input$plafond_GIR3_ini,
                                       plafond_GIR4_ini = input$plafond_GIR4_ini,
                                       hyp_evol_plafond = input$hyp_evol_plafond,
                                       pourc_plan_consomme_GIR1 = input$pourc_plan_consomme_GIR1,
                                       pourc_plan_consomme_GIR2 = input$pourc_plan_consomme_GIR2,
                                       pourc_plan_consomme_GIR3 = input$pourc_plan_consomme_GIR3,
                                       pourc_plan_consomme_GIR4 = input$pourc_plan_consomme_GIR4,
                                       pourc_plan_consomme_GIR1_HI = input$pourc_plan_consomme_GIR1_HI,
                                       pourc_plan_consomme_GIR2_HI = input$pourc_plan_consomme_GIR2_HI,
                                       pourc_plan_consomme_GIR3_HI = input$pourc_plan_consomme_GIR3_HI,
                                       pourc_plan_consomme_GIR4_HI = input$pourc_plan_consomme_GIR4_HI,
                                       nb_heures_GIR1 = input$nb_heures_GIR1,
                                       nb_heures_GIR2 = input$nb_heures_GIR2,
                                       nb_heures_GIR3 = input$nb_heures_GIR3,
                                       nb_heures_GIR4 = input$nb_heures_GIR4,
                                       cout_heure_dom_presta = input$cout_heure_dom_presta,
                                       evol_cout_heure_dom_presta = input$evol_cout_heure_dom_presta,
                                       cout_heure_dom_greagre = input$cout_heure_dom_greagre,
                                       pourc_h_greagre_GIR1 = input$pourc_h_greagre_GIR1,
                                       pourc_h_greagre_GIR2 = input$pourc_h_greagre_GIR2,
                                       pourc_h_greagre_GIR3 = input$pourc_h_greagre_GIR3,
                                       pourc_h_greagre_GIR4 = input$pourc_h_greagre_GIR4,
                                       evol_cout_heure_dom_greagre = input$evol_cout_heure_dom_greagre,
                                       evol_cout_etab = input$evol_cout_etab,
                                       cout_HI = input$cout_HI,
                                       cout_hors_aide_humaine = input$cout_hors_aide_humaine)})
  
  table_departementale <- reactive({table_dpt(tauxGIR1dansGIR12_d = input$tauxGIR1dansGIR12_d,
                                           tauxGIR3dansGIR34_d = input$tauxGIR3dansGIR34_d,
                                           tauxGIR1dansGIR12_e = input$tauxGIR1dansGIR12_e,
                                           tauxGIR3dansGIR34_e = input$tauxGIR3dansGIR34_e,
                                           tx_recours_APA_GIR1_d = input$tx_recours_APA_GIR1_d,
                                           tx_recours_APA_GIR2_d = input$tx_recours_APA_GIR2_d,
                                           tx_recours_APA_GIR3_d = input$tx_recours_APA_GIR3_d,
                                           tx_recours_APA_GIR4_d = input$tx_recours_APA_GIR4_d,
                                           tx_recours_APA_GIR1_e = input$tx_recours_APA_GIR1_e,
                                           tx_recours_APA_GIR2_e = input$tx_recours_APA_GIR2_e,
                                           tx_recours_APA_GIR3_e = input$tx_recours_APA_GIR3_e,
                                           tx_recours_APA_GIR4_e = input$tx_recours_APA_GIR4_e,
                                           plafond_GIR1_ini = input$plafond_GIR1_ini,
                                           plafond_GIR2_ini = input$plafond_GIR2_ini,
                                           plafond_GIR3_ini = input$plafond_GIR3_ini,
                                           plafond_GIR4_ini = input$plafond_GIR4_ini,
                                           hyp_evol_plafond = input$hyp_evol_plafond,
                                           pourc_plan_consomme_GIR1 = input$pourc_plan_consomme_GIR1,
                                           pourc_plan_consomme_GIR2 = input$pourc_plan_consomme_GIR2,
                                           pourc_plan_consomme_GIR3 = input$pourc_plan_consomme_GIR3,
                                           pourc_plan_consomme_GIR4 = input$pourc_plan_consomme_GIR4,
                                           pourc_plan_consomme_GIR1_HI = input$pourc_plan_consomme_GIR1_HI,
                                           pourc_plan_consomme_GIR2_HI = input$pourc_plan_consomme_GIR2_HI,
                                           pourc_plan_consomme_GIR3_HI = input$pourc_plan_consomme_GIR3_HI,
                                           pourc_plan_consomme_GIR4_HI = input$pourc_plan_consomme_GIR4_HI,
                                           nb_heures_GIR1 = input$nb_heures_GIR1,
                                           nb_heures_GIR2 = input$nb_heures_GIR2,
                                           nb_heures_GIR3 = input$nb_heures_GIR3,
                                           nb_heures_GIR4 = input$nb_heures_GIR4,
                                           cout_heure_dom_presta = input$cout_heure_dom_presta,
                                           evol_cout_heure_dom_presta = input$evol_cout_heure_dom_presta,
                                           cout_heure_dom_greagre = input$cout_heure_dom_greagre,
                                           pourc_h_greagre_GIR1 = input$pourc_h_greagre_GIR1,
                                           pourc_h_greagre_GIR2 = input$pourc_h_greagre_GIR2,
                                           pourc_h_greagre_GIR3 = input$pourc_h_greagre_GIR3,
                                           pourc_h_greagre_GIR4 = input$pourc_h_greagre_GIR4,
                                           evol_cout_heure_dom_greagre = input$evol_cout_heure_dom_greagre,
                                           evol_cout_etab = input$evol_cout_etab,
                                           cout_HI = input$cout_HI,
                                           cout_hors_aide_humaine = input$cout_hors_aide_humaine)})
  
  output$plot_national <- renderPlot({
    
    data <- switch(input$tendance_nationale,
                   "Dépense d'APA"                                       = df_national(),
                   "Dépense d'APA et OGD"                                = df_OGD(),
                   "Nombre de bénéficiaires de l'APA"                    = df_national(),
                   "Nombre de personnes âgées"                           = df_national(),
                   "Nombre de personnes âgée en GIR 1-4"                 = df_national(),
                   "Nombre de points GIR 1-4"                            = df_national(),
                   "Nombre de points GIR 1-6"                            = df_national(),
                   "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = df_national(),
                   "Nombre d'ETP en SAAD"                                = df_national(),
                   "Nombre de places en SSIAD"                           = df_national(),
                   "Nombre de places en HAD"                             = df_national(),
                   "Nombre d'infirmières libérales (en ETP)"             = df_national(),
                   "Nombre de personnel en établissement(en ETP)"        = df_national(),
    )
    
    trend <- switch(input$tendance_nationale,
                   "Dépense d'APA"                                       = data$depenseAPA,
                   "Dépense d'APA et OGD"                                = data$depenseAPA_OGD,
                   "Nombre de bénéficiaires de l'APA"                    = data$nbbenAPA,
                   "Nombre de personnes âgées"                           = data$nbpers,
                   "Nombre de personnes âgée en GIR 1-4"                 = data$nbGIR14,
                   "Nombre de points GIR 1-4"                            = data$points_GIR14,
                   "Nombre de points GIR 1-6"                            = data$points_GIR16,
                   "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = data$points_GIR_APA,
                   "Nombre d'ETP en SAAD"                                = data$nb_etp_saad,
                   "Nombre de places en SSIAD"                           = data$nb_places_ssiad,
                   "Nombre de places en HAD"                             = data$nb_places_had,
                   "Nombre d'infirmières libérales (en ETP)"             = data$nb_etp_infirmieres_liberales,
                   "Nombre de personnel en établissement(en ETP)"        = data$nb_etp_etablissement
                   )
  
  unit_trend <- switch(input$tendance_nationale,
                       "Dépense d'APA"                                       = "M",
                       "Dépense d'APA et OGD"                                = "M",
                       "Nombre de bénéficiaires de l'APA"                    = "M",
                       "Nombre de personnes âgées"                           = "M",
                       "Nombre de personnes âgée en GIR 1-4"                 = "M",
                       "Nombre de points GIR 1-4"                            = "M",
                       "Nombre de points GIR 1-6"                            = "M",
                       "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = "M",
                       "Nombre d'ETP en SAAD"                                = "m",
                       "Nombre de places en SSIAD"                           = "m",
                       "Nombre de places en HAD"                             = "m",
                       "Nombre d'infirmières libérales (en ETP)"             = "m",
                       "Nombre de personnel en établissement(en ETP)"        = "m"
  )
  
  scale_trend <- switch(input$tendance_nationale,
                        "Dépense d'APA"                                       = 1e-6,
                        "Dépense d'APA et OGD"                                = 1e-6,
                        "Nombre de bénéficiaires de l'APA"                    = 1e-6,
                        "Nombre de personnes âgées"                           = 1e-6,
                        "Nombre de personnes âgée en GIR 1-4"                 = 1e-6,
                        "Nombre de points GIR 1-4"                            = 1e-6,
                        "Nombre de points GIR 1-6"                            = 1e-6,
                        "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = 1e-6,
                        "Nombre d'ETP en SAAD"                                = 1e-3,
                        "Nombre de places en SSIAD"                           = 1e-3,
                        "Nombre de places en HAD"                             = 1e-3,
                        "Nombre d'infirmières libérales (en ETP)"             = 1e-3,
                        "Nombre de personnel en établissement(en ETP)"        = 1e-3
  )
  
  colors_values <- switch(input$tendance_nationale,
                          "Dépense d'APA"                                       = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Dépense d'APA et OGD"                                = c("darkorange2", "cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de bénéficiaires de l'APA"                    = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de personnes âgées"                           = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de personnes âgée en GIR 1-4"                 = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de points GIR 1-4"                            = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de points GIR 1-6"                            = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre d'ETP en SAAD"                                = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de places en SSIAD"                           = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de places en HAD"                             = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre d'infirmières libérales (en ETP)"             = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de personnel en établissement(en ETP)"        = c("cornflowerblue", "darkorchid", "bisque1")
  )
  
  colors_labels <- switch(input$tendance_nationale,
                          "Dépense d'APA"                                       = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Dépense d'APA et OGD"                                = c("OGD","Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de bénéficiaires de l'APA"                    = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de personnes âgées"                           = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de personnes âgée en GIR 1-4"                 = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de points GIR 1-4"                            = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de points GIR 1-6"                            = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre d'ETP en SAAD"                                = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de places en SSIAD"                           = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de places en HAD"                             = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre d'infirmières libérales (en ETP)"             = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de personnel en établissement(en ETP)"        = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire")
  )
  
  unit_names <- switch(input$tendance_nationale,
                       "Dépense d'APA"                                       = "millions",
                       "Dépense d'APA et OGD"                                = "millions",
                       "Nombre de bénéficiaires de l'APA"                    = "millions",
                       "Nombre de personnes âgées"                           = "millions",
                       "Nombre de personnes âgée en GIR 1-4"                 = "millions",
                       "Nombre de points GIR 1-4"                            = "millions",
                       "Nombre de points GIR 1-6"                            = "millions",
                       "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = "millions",
                       "Nombre d'ETP en SAAD"                                = "milliers",
                       "Nombre de places en SSIAD"                           = "milliers",
                       "Nombre de places en HAD"                             = "milliers",
                       "Nombre d'infirmières libérales (en ETP)"             = "milliers",
                       "Nombre de personnel en établissement(en ETP)"        = "milliers"
  )
    
    ggplot(data=data, aes(x=annee, y=trend, fill=habitat)) +
      geom_bar(stat="identity") +
      scale_y_continuous(labels = unit_format(unit = unit_trend, scale = scale_trend)) +
      scale_x_continuous(breaks=seq(2020, 2050, 5)) +
      scale_fill_manual(values = colors_values, 
                        labels = colors_labels,
                        name = "") +
      theme(
        panel.background = element_rect(fill = "white"),
        panel.grid.minor.y = element_line(color = "grey"),
        legend.position="bottom",
        plot.title = element_text(hjust = 0.5),
        axis.line = element_line(colour = "black", 
                                 size = 1, linetype = "solid")
      ) +
      labs(title = input$tendance_nationale) +
      xlab("Année") +
      ylab(paste0("Valeur (en ", unit_names, " )"))
    
  },
  height = 700,
  width  = 1600
  )

output$plot_departemental <- renderPlot({
  
  data <- switch(input$tendance_departementale,
                 "Dépense d'APA"                                       = df_departemental(),
                 "Dépense d'APA et OGD"                                = df_OGD_dpt(),
                 "Nombre de bénéficiaires de l'APA"                    = df_departemental(),
                 "Nombre de personnes âgées"                           = df_departemental(),
                 "Nombre de personnes âgée en GIR 1-4"                 = df_departemental(),
                 "Nombre de points GIR 1-4"                            = df_departemental(),
                 "Nombre de points GIR 1-6"                            = df_departemental(),
                 "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = df_departemental(),
                 "Nombre d'ETP en SAAD"                                = df_departemental(),
                 "Nombre de places en SSIAD"                           = df_departemental(),
                 "Nombre de places en HAD"                             = df_departemental(),
                 "Nombre d'infirmières libérales (en ETP)"             = df_departemental(),
                 "Nombre de personnel en établissement(en ETP)"        = df_departemental(),
  )
  
  data_dpt <-  data %>% filter(DEP == substr(input$departement, 1, 2))
  
  trend <- switch(input$tendance_departementale,
                  "Dépense d'APA"                                       = data_dpt$depenseAPA,
                  "Dépense d'APA et OGD"                                = data_dpt$depenseAPA_OGD,
                  "Nombre de bénéficiaires de l'APA"                    = data_dpt$nbbenAPA,
                  "Nombre de personnes âgées"                           = data_dpt$nbpers,
                  "Nombre de personnes âgée en GIR 1-4"                 = data_dpt$nbGIR14,
                  "Nombre de points GIR 1-4"                            = data_dpt$points_GIR14,
                  "Nombre de points GIR 1-6"                            = data_dpt$points_GIR16,
                  "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = data_dpt$points_GIR_APA,
                  "Nombre d'ETP en SAAD"                                = data_dpt$nb_etp_saad,
                  "Nombre de places en SSIAD"                           = data_dpt$nb_places_ssiad,
                  "Nombre de places en HAD"                             = data_dpt$nb_places_had,
                  "Nombre d'infirmières libérales (en ETP)"             = data_dpt$nb_etp_infirmieres_liberales,
                  "Nombre de personnel en établissement(en ETP)"        = data_dpt$nb_etp_etablissement
  )
  
  unit_trend <- switch(input$tendance_departementale,
                       "Dépense d'APA"                                       = "M",
                       "Dépense d'APA et OGD"                                = "M",
                       "Nombre de bénéficiaires de l'APA"                    = "m",
                       "Nombre de personnes âgées"                           = "m",
                       "Nombre de personnes âgée en GIR 1-4"                 = "m",
                       "Nombre de points GIR 1-4"                            = "M",
                       "Nombre de points GIR 1-6"                            = "M",
                       "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = "M",
                       "Nombre d'ETP en SAAD"                                = "",
                       "Nombre de places en SSIAD"                           = "",
                       "Nombre de places en HAD"                             = "",
                       "Nombre d'infirmières libérales (en ETP)"             = "",
                       "Nombre de personnel en établissement(en ETP)"        = ""
  )
  
  scale_trend <- switch(input$tendance_departementale,
                        "Dépense d'APA"                                       = 1e-6,
                        "Dépense d'APA et OGD"                                = 1e-6,
                        "Nombre de bénéficiaires de l'APA"                    = 1e-3,
                        "Nombre de personnes âgées"                           = 1e-3,
                        "Nombre de personnes âgée en GIR 1-4"                 = 1e-3,
                        "Nombre de points GIR 1-4"                            = 1e-6,
                        "Nombre de points GIR 1-6"                            = 1e-6,
                        "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = 1e-6,
                        "Nombre d'ETP en SAAD"                                = 1,
                        "Nombre de places en SSIAD"                           = 1,
                        "Nombre de places en HAD"                             = 1,
                        "Nombre d'infirmières libérales (en ETP)"             = 1,
                        "Nombre de personnel en établissement(en ETP)"        = 1
  )
  
  colors_values <- switch(input$tendance_departementale,
                          "Dépense d'APA"                                       = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Dépense d'APA et OGD"                                = c("darkorange2", "cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de bénéficiaires de l'APA"                    = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de personnes âgées"                           = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de personnes âgée en GIR 1-4"                 = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de points GIR 1-4"                            = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de points GIR 1-6"                            = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre d'ETP en SAAD"                                = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de places en SSIAD"                           = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de places en HAD"                             = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre d'infirmières libérales (en ETP)"             = c("cornflowerblue", "darkorchid", "bisque1"),
                          "Nombre de personnel en établissement(en ETP)"        = c("cornflowerblue", "darkorchid", "bisque1")
  )
  
  colors_labels <- switch(input$tendance_departementale,
                          "Dépense d'APA"                                       = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Dépense d'APA et OGD"                                = c("OGD","Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de bénéficiaires de l'APA"                    = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de personnes âgées"                           = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de personnes âgée en GIR 1-4"                 = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de points GIR 1-4"                            = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de points GIR 1-6"                            = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre d'ETP en SAAD"                                = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de places en SSIAD"                           = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de places en HAD"                             = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre d'infirmières libérales (en ETP)"             = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire"),
                          "Nombre de personnel en établissement(en ETP)"        = c("Ehpad et assimilés", "Résidence autonomie", "Ménage ordinaire")
  )
  
  unit_names <- switch(input$tendance_departementale,
                       "Dépense d'APA"                                       = "millions",
                       "Dépense d'APA et OGD"                                = "millions",
                       "Nombre de bénéficiaires de l'APA"                    = "milliers",
                       "Nombre de personnes âgées"                           = "milliers",
                       "Nombre de personnes âgée en GIR 1-4"                 = "milliers",
                       "Nombre de points GIR 1-4"                            = "millions",
                       "Nombre de points GIR 1-6"                            = "millions",
                       "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = "millions",
                       "Nombre d'ETP en SAAD"                                = "",
                       "Nombre de places en SSIAD"                           = "",
                       "Nombre de places en HAD"                             = "",
                       "Nombre d'infirmières libérales (en ETP)"             = "",
                       "Nombre de personnel en établissement(en ETP)"        = ""
  )
  
  y_legend <- switch(input$tendance_departementale,
                     "Dépense d'APA"                                       = "Valeur (en millions)",
                     "Dépense d'APA et OGD"                                = "Valeur (en millions)",
                     "Nombre de bénéficiaires de l'APA"                    = "Valeur (en milliers)",
                     "Nombre de personnes âgées"                           = "Valeur (en milliers)",
                     "Nombre de personnes âgée en GIR 1-4"                 = "Valeur (en milliers)",
                     "Nombre de points GIR 1-4"                            = "Valeur (en millions)",
                     "Nombre de points GIR 1-6"                            = "Valeur (en millions)",
                     "Nombre de points GIR 1-4 des bénéficiaires de l'APA" = "Valeur (en millions)",
                     "Nombre d'ETP en SAAD"                                = "Valeur",
                     "Nombre de places en SSIAD"                           = "Valeur",
                     "Nombre de places en HAD"                             = "Valeur",
                     "Nombre d'infirmières libérales (en ETP)"             = "Valeur",
                     "Nombre de personnel en établissement(en ETP)"        = "Valeur"
  )
  
  ggplot(data=data_dpt, aes(x=annee, y=trend, fill=habitat)) +
    geom_bar(stat="identity") +
    scale_y_continuous(labels = unit_format(unit = unit_trend, scale = scale_trend)) +
    scale_x_continuous(breaks=seq(2020, 2050, 5)) +
    scale_fill_manual(values = colors_values, 
                      labels = colors_labels,
                      name = "") +
    theme(
      panel.background = element_rect(fill = "white"),
      panel.grid.minor.y = element_line(color = "grey"),
      legend.position="bottom",
      plot.title = element_text(hjust = 0.5),
      axis.line = element_line(colour = "black", 
                               size = 1, linetype = "solid")
    ) +
    labs(title = input$tendance_departementale) +
    xlab("Année") +
    ylab(y_legend)
  
},
height = 700,
width  = 1600
)

output$table_nationale <- renderDT({
  
  filtre_annee <- switch(
    input$annee,
    "2020" = c(2020), "2021" = c(2021), "2022" = c(2022), "2023" = c(2023), "2024" = c(2024), "2025" = c(2025), "2026" = c(2026), "2027" = c(2027),
    "2028" = c(2028), "2029" = c(2029), "2030" = c(2030), "2031" = c(2031), "2032" = c(2032), "2033" = c(2033), "2034" = c(2034), "2035" = c(2035),
    "2036" = c(2036), "2037" = c(2037), "2038" = c(2038), "2039" = c(2039), "2040" = c(2040), "2041" = c(2041), "2042" = c(2042), "2043" = c(2043),
    "2044" = c(2044), "2045" = c(2045), "2046" = c(2046), "2047" = c(2047), "2048" = c(2048), "2049" = c(2049), "2050" = c(2050),
    "Toutes les années" = c(2020, 2021, 2022, 2023, 2024, 2025, 2026, 2027, 2028, 2029,
                          2030, 2031, 2032, 2033, 2034, 2035, 2036, 2037, 2038, 2039,
                          2040, 2041, 2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049,
                          2050)
  )
  
  filtre_habitat <- switch(
    input$habitat,
    "Ehpad et assimilés"   = c("Ehpad et assimilés"),
    "Ménage ordinaire"     = c("Ménage ordinaire"),
    "Résidence autonomie"  = c("Résidence autonomie"),
    "Tous les lieux de vie" = c("Ehpad et assimilés", "Ménage ordinaire", "Résidence autonomie", "Total")
  )
  
  df <- table_nationale()
  
  df <- df %>% filter(Année %in% filtre_annee & Habitat %in% filtre_habitat)
  
  print(df)

},
rownames = FALSE,
options = list(pageLength = 20, info = FALSE, scrollX = TRUE)
)

output$table_departementale <- renderDT({
  
  filtre_annee_dpt <- switch(
    input$annee_dpt,
    "2020" = c(2020), "2021" = c(2021), "2022" = c(2022), "2023" = c(2023), "2024" = c(2024), "2025" = c(2025), "2026" = c(2026), "2027" = c(2027),
    "2028" = c(2028), "2029" = c(2029), "2030" = c(2030), "2031" = c(2031), "2032" = c(2032), "2033" = c(2033), "2034" = c(2034), "2035" = c(2035),
    "2036" = c(2036), "2037" = c(2037), "2038" = c(2038), "2039" = c(2039), "2040" = c(2040), "2041" = c(2041), "2042" = c(2042), "2043" = c(2043),
    "2044" = c(2044), "2045" = c(2045), "2046" = c(2046), "2047" = c(2047), "2048" = c(2048), "2049" = c(2049), "2050" = c(2050),
    "Toutes les années" = c(2020, 2021, 2022, 2023, 2024, 2025, 2026, 2027, 2028, 2029,
                            2030, 2031, 2032, 2033, 2034, 2035, 2036, 2037, 2038, 2039,
                            2040, 2041, 2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049,
                            2050)
  )
  
  filtre_habitat_dpt <- switch(
    input$habitat_dpt,
    "Ehpad et assimilés"    = c("Ehpad et assimilés"),
    "Ménage ordinaire"      = c("Ménage ordinaire"),
    "Résidence autonomie"   = c("Résidence autonomie"),
    "Tous les lieux de vie" = c("Ehpad et assimilés", "Ménage ordinaire", "Résidence autonomie", "Total")
  )
  
  filtre_departement <- switch(
    input$departement_dpt,
    "01 - Ain"                     = c("01"),
    "02 - Aisne"                   = c("02"),
    "03 - Allier"                  = c("03"),
    "04 - Alpes de Haute-Garonne"  = c("04"),
    "05 - Hautes-Alpes"            = c("05"),
    "06 - Alpes-Maritimes"         = c("06"),
    "07 - Ardèche"                 = c("07"),
    "08 - Ardennes"                = c("08"),
    "09 - Ariège"                  = c("09"),
    "10 - Aube"                    = c("10"),
    "11 - Aude"                    = c("11"),
    "12 - Aveyron"                 = c("12"),
    "13 - Bouches-du-Rhône"        = c("13"),
    "14 - Calvados"                = c("14"),
    "15 - Cantal"                  = c("15"),
    "16 - Charente"                = c("16"),
    "17 - Charente-Maritime"       = c("17"),    
    "18 - Cher"                    = c("18"),
    "19 - Corrèze"                 = c("19"),
    "21 - Côte d'Or"               = c("21"),
    "22 - Côtes d'Armor"           = c("22"),
    "23 - Creuse"                  = c("23"),
    "24 - Dordogne"                = c("24"),
    "25 - Doubs"                   = c("25"),
    "26 - Drôme"                   = c("26"),
    "27 - Eure"                    = c("27"),
    "28 - Eure-et-Loire"           = c("28"),
    "29 - Finistère"               = c("29"),
    "2A - Corse-du-Sud"            = c("2A"),
    "2B - Haute-Corse"             = c("2B"),
    "30 - Gard"                    = c("30"),
    "31 - Haute-Garonne"           = c("31"),
    "32 - Gers"                    = c("32"),
    "33 - Gironde"                 = c("33"),
    "34 - Hérault"                 = c("34"),
    "35 - Ille-et-Vilaine"         = c("35"),
    "36 - Indre"                   = c("36"),
    "37 - Indre-et-Loire"          = c("37"),
    "38 - Isère"                   = c("38"),
    "39 - Jura"                    = c("39"),
    "40 - Landes"                  = c("40"),
    "41 - Loire-et-Cher"           = c("41"),
    "42 - Loire"                   = c("42"),
    "43 - Haute-Loire"             = c("43"),
    "44 - Loire-Atlantique"        = c("44"),
    "45 - Loiret"                  = c("45"),
    "46 - Lot"                     = c("46"),
    "47 - Lot-et-Garonne"          = c("47"),
    "48 - Lozère"                  = c("48"),
    "49 - Maine-et-Loire"          = c("49"),
    "50 - Manche"                  = c("50"),
    "51 - Marne"                   = c("51"),
    "52 - Haute-Marne"             = c("52"),
    "53 - Mayenne"                 = c("53"),
    "54 - Meurthe-et-Moselle"      = c("54"),
    "55 - Meuse"                   = c("55"),
    "56 - Morbihan"                = c("56"),
    "57 - Moselle"                 = c("57"),
    "58 - Nièvre"                  = c("58"),
    "59 - Nord"                    = c("59"),
    "60 - Oise"                    = c("60"),
    "61 - Orne"                    = c("61"),
    "62 - Pas-de-Calais"           = c("62"),
    "63 - Puy-de-Dôme"             = c("63"),
    "64 - Pyrénées-Atlantiques"    = c("64"),
    "65 - Hautes-Pyrénées"         = c("65"),
    "66 - Pyrénées Orientales"     = c("66"),
    "67 - Bas-Rhin"                = c("67"),
    "68 - Haut-Rhin"               = c("68"),
    "69 - Rhône"                   = c("69"),
    "70 - Haute-Saône"             = c("70"),
    "71 - Saône-et-Loire"          = c("71"),
    "72 - Sarthe"                  = c("72"),
    "73 - Savoie"                  = c("73"),
    "74 - Haute-Savoie"            = c("74"),
    "75 - Paris"                   = c("75"),
    "76 - Seine-Maritime"          = c("76"),
    "77 - Seine-et-Marne"          = c("77"),
    "78 - Yvelines"                = c("78"),
    "79 - Deux-Sèvres"             = c("79"),
    "80 - Somme"                   = c("80"),
    "81 - Tarn"                    = c("81"),
    "82 - Tarn-et-Garonne"         = c("82"),
    "83 - Var"                     = c("83"),
    "84 - Vaucluse"                = c("84"),
    "85 - Vendée"                  = c("85"),
    "86 - Vienne"                  = c("86"),
    "87 - Haute-Vienne"            = c("87"),
    "88 - Vosges"                  = c("88"),
    "89 - Yonne"                   = c("89"),
    "90 - Territoire de Belfort"   = c("90"),
    "91 - Essonne"                 = c("91"),
    "92 - Hauts-de-Seine"          = c("92"),
    "93 - Seine-Saint-Denis"       = c("93"),
    "94 - Val-de-Marne"            = c("94"),
    "95 - Val d'Oise"              = c("95"),
    "97 - DOM-TOM"                 = c("97"),
    "Tous les départements"        = c("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19",
                                       "21", "22", "23", "24", "25", "26", "27", "28", "29", "2A", "2B", "30", "31", "32", "33", "34", "35", "36", "37",
                                       "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56",
                                       "57", "58", "59", "60", "61", "62", "63", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", 
                                       "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "90", "91", "92", "93", "94", 
                                       "95", "97")
  )
  
  df <- table_departementale()
  
  df <- df %>% filter(Année %in% filtre_annee_dpt & Habitat %in% filtre_habitat_dpt & Département %in% filtre_departement)
  
  print(df)
  
},
rownames = FALSE,
options = list(pageLength = 20, info = FALSE, scrollX = TRUE)
)

}

# Run the app ----
shiny::shinyApp(ui = ui, server = server)
